#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>

#define PI 3.14159265
#define MAX 11
#define BUYUT 30
#define ODAK 150
#define PERDE -150
#define BIRKOK 0.70710678

void KupuYerlestir(float xx[], float yy[], float zz[]){
    xx[0] = 0.0;    yy[0] = 0.0;    zz[0] = 0.0;
    xx[1] = 1.0;    yy[1] = 0.0;    zz[1] = 0.0;
    xx[2] = 1.0;    yy[2] = 1.0;    zz[2] = 0.0;
    xx[3] = 0.0;    yy[3] = 1.0;    zz[3] = 0.0;
    xx[4] = 0.0;    yy[4] = 0.0;    zz[4] = 1.0;
    xx[5] = 1.0;    yy[5] = 0.0;    zz[5] = 1.0;
    xx[6] = 1.0;    yy[6] = 1.0;    zz[6] = 1.0;
    xx[7] = 0.0;    yy[7] = 1.0;    zz[7] = 1.0;
    xx[8] = 0.0;    yy[8] = 0.0;    zz[8] = 3.0;
    xx[9] = 0.0;    yy[9] = 2.0;    zz[9] = 0.0;
    xx[10]= 2.0;    yy[10]= 0.0;    zz[10]= 0.0;
}
void SonKoordinatlar(float x1[], float y1[], float z1[], float x2[], float y2[], float z2[], int tip){
    int i;
    for(i=0; i<MAX; i++){
        if(tip == 0){
	    x2[i] = x1[i] * BUYUT - 10;
	    y2[i] = y1[i] * BUYUT - 10;
	}else{
	    x2[i] = x1[i] * BUYUT/2 - 10;
	    y2[i] = y1[i] * BUYUT/2 - 10;
	}
        z2[i] = z1[i] * BUYUT;
    }
}
void YedekSonKoordinatlar(float x1[], float y1[], float z1[], float x2[], float y2[], float z2[], int artis, int tip){
    int i;
    for(i=0; i<MAX; i++){
        if(tip == 0){
	    x2[i] = x1[i] + artis;
	    y2[i] = y1[i] + artis;
	    z2[i] = z1[i] - artis;
	}else{
	    x2[i] = x1[i];
	    y2[i] = y1[i];
	    z2[i] = z1[i];
        }
    }
}
void Ilerlet(float x1[], float y1[], float z1[], int yol){
// DONDUR + ILERLET + GERI_DON
    int i;
    if(yol > 30)
       yol = 30;
    for(i = 0; i<MAX; i++){
	x1[i] = x1[i] + yol*BUYUT*BIRKOK/30;
	y1[i] = y1[i] + yol*BUYUT*BIRKOK/30;
    }
}
void Dondur(float x1[], float y1[], float z1[], int alfa){
// DONDUR
    int i;
    for(i = 0; i<MAX; i++){
	x1[i] = x1[i]*cos(alfa*PI/180) + (1-cos(alfa*PI/180))*(x1[i]+z1[i])/2 - sin(alfa*PI/180)*BIRKOK*y1[i];
	y1[i] = y1[i]*cos(alfa*PI/180) + sin(alfa*PI/180)*BIRKOK*(x1[i] - z1[i]);
	z1[i] = z1[i]*cos(alfa*PI/180) + (1-cos(alfa*PI/180))*(x1[i]+z1[i])/2 + sin(alfa*PI/180)*BIRKOK*y1[i];
    }
}
void KupuEg(float x2[], float y2[], float z2[]){
    int i;
    for(i=0; i<MAX; i++){
	x2[i] = x2[i] * (ODAK - PERDE) / (ODAK - z2[i]) + 30 ;
	y2[i] = y2[i] * (ODAK - PERDE) / (ODAK - z2[i]) + 30 ;
    }
}
void KupuCiz(float xx[], float yy[], float tip){
    if(tip == 2){
	setcolor(15);
        line(xx[0], yy[0], xx[9], yy[9]);
        line(xx[0], yy[0], xx[10], yy[10]);
	line(xx[0], yy[0], xx[8], yy[8]);
    }
    if(tip == 1)
	setcolor(12);
    else
        setcolor(14);
    if(tip == 0){
	setcolor(15);
        line(xx[0], yy[0], xx[9], yy[9]);
        line(xx[0], yy[0], xx[10], yy[10]);
	line(xx[0], yy[0], xx[8], yy[8]);
        if(tip == 0){
	    setcolor(14);
	    line(15,120,20,130);
	    line(15,130,20,120);
	    line(130,15,125,25);
	    line(123,15,127,20);
	}
	setcolor(10);
    }
    moveto(xx[3], yy[3]);
    lineto(xx[0], yy[0]);
    lineto(xx[1], yy[1]);
    lineto(xx[2], yy[2]);
    lineto(xx[3], yy[3]);
    lineto(xx[7], yy[7]);
    lineto(xx[4], yy[4]);
    lineto(xx[5], yy[5]);
    lineto(xx[6], yy[6]);
    lineto(xx[7], yy[7]);
    line(xx[0], yy[0], xx[4], yy[4]);
    line(xx[1], yy[1], xx[5], yy[5]);
    line(xx[2], yy[2], xx[6], yy[6]);
    setcolor(14);
    if(tip<1)
	rectangle(xx[2]-1,yy[2]-1,xx[2]+1,yy[2]+1);
}

void main(){
    FILE *f;
    void *pt;
    unsigned int imsize;
    int Adapter = 0;
    int Mod;
    char *dir = "C:\\TC\\BGI";

    float x[MAX], y[MAX], z[MAX];
    float sonX[MAX], sonY[MAX], sonZ[MAX];
    float yedekX[MAX], yedekY[MAX], yedekZ[MAX];
    int art, artmaOrani, bekle, sayac;

    int l = 50, OdevNo;
    float Q, L, w = 30.0, q = 20.0, t = 0.0;

    float Hiz, Artis, Konum;

    printf("    BEYCAN KAHRAMAN\n       040020337\n");
    while(1){
      printf("\n-----------------------------------------\ndev Noyu Giriniz (IKIS = 0) : ");
      scanf("%d", &OdevNo);
      printf("-----------------------------------------\n");
      if(OdevNo < 1 || OdevNo > 4)
	break;
      switch(OdevNo){
	case 1:
	    art = 0;
            bekle = 0;
	    artmaOrani=1;
            detectgraph(&Adapter, &Mod);
	    initgraph(&Adapter, &Mod, dir);
	    setcolor(2);
	    printf("\n   CEVAP 1");
	    printf("\n   (1,1,0),(2,1,0),(2,2,0),(1,2,0),");
	    printf("\n   (1,1,-1),(2,1,-1),(2,2,-1),(1,2,-1)");
	    printf("\n   kp aranan kptr...");
	    setcolor(5);
	    moveto(3, 3);
	    lineto(3, 308);
	    lineto(308, 308);
	    lineto(308, 3);
	    lineto(3, 3);
	    KupuYerlestir(x, y, z);
	    imsize = (0, 0, 200, 200);
	    pt = malloc(imsize);
	    while(!kbhit()){
		setactivepage(1);
		clearviewport();
		SonKoordinatlar(x,y,z,sonX,sonY,sonZ,0);
		YedekSonKoordinatlar(sonX,sonY,sonZ,yedekX,yedekY,yedekZ,art,0);
		KupuEg(sonX,sonY,sonZ);
		KupuEg(yedekX, yedekY, yedekZ);
		if(bekle > 0)
                    KupuCiz(yedekX,yedekY,2);
                else
		    KupuCiz(yedekX,yedekY,1);
		KupuCiz(sonX,sonY,0);
                if(bekle == 0)
		    art += artmaOrani;
		if(art >= BUYUT || art == 0)
		    bekle++;
                if(bekle == 20){
		   artmaOrani = -artmaOrani;
                   bekle = 0;
                }
		getimage(0, 0, 200, 200, pt);
	        setactivepage(0);
		putimage(50, 100, pt, 0);
	        setvisualpage(0);
	    }
	    free(pt);
	    getch();
	    closegraph();
	  break;
	case 2:
            detectgraph(&Adapter, &Mod);
	    initgraph(&Adapter, &Mod, dir);
	    setcolor(2);
	    printf("\n   CEVAP 2");
	    printf("\n  (2.894,3.653,0.312), (4.874,4.378,0.491),");
	    printf("\n  (4.185,6.037,6.727), (2.169,5.263,0.550),");
	    printf("\n  (3.410,2.350,1.954), (5.814,3.197,2.133),");
	    printf("\n  (5.006,5.177,2.371), (2.547,4.259,2.192),");
	    printf("\n  kp aranan kptr...");
	    setcolor(5);
	    moveto(3, 3);
	    lineto(3, 308);
	    lineto(358, 308);
	    lineto(358, 3);
	    lineto(3, 3);
	    KupuYerlestir(x, y, z);
	    sayac = 0;
            bekle = 0;
	    imsize = (0, 0, 200, 150);
	    pt = malloc(imsize);
	    while(!kbhit()){
                if(sayac < 60)
		    sayac++;
		else
		    bekle++;
		if(bekle == 20){
		    sayac = 0;
		    bekle = 0;
		}
		setactivepage(1);
		clearviewport();
		SonKoordinatlar(x,y,z,sonX,sonY,sonZ,1);
		YedekSonKoordinatlar(sonX,sonY,sonZ,yedekX,yedekY,yedekZ,art,1);
		Ilerlet(yedekX,yedekY,yedekZ,sayac);
		if(sayac > 30)
		    Dondur(yedekX,yedekY,yedekZ,sayac-30);
		KupuEg(sonX,sonY,sonZ);
		KupuEg(yedekX, yedekY, yedekZ);
		KupuCiz(yedekX,yedekY,1);
		KupuCiz(sonX,sonY,2);
		getimage(0, 0, 200, 150, pt);
		setactivepage(0);
		putimage(80, 150, pt, 0);
		setvisualpage(0);
	    }
	    free(pt);
	    getch();
	    closegraph();
	  break;
	  break;
	case 3:
	  detectgraph(&Adapter, &Mod);
	  initgraph(&Adapter, &Mod, dir);
          setcolor(2);
	  printf("\n   CEVAP 3");
	  setcolor(5);
	  moveto(3, 3);
	  lineto(3, 303);
	  lineto(303, 303);
	  lineto(303, 3);
	  lineto(3, 3);
	  setcolor(7);
	  line(74, 49, 226, 49);
	  setcolor(6);
	  line(74, 201, 226, 201);
	  imsize = (0, 0, 150, 150);
	  pt = malloc(imsize);
	  while(!kbhit()){
	      setactivepage(1);
	      clearviewport();
	      setcolor(10);
	      t += 0.3;
	      Q = l*cos((w*t + q)*PI/180);
	      L = sqrt(14400 - Q*Q);
	      line(75, 0, 75 + Q, 0 + L);
	      setcolor(11);
	      circle(75 + Q, L, 5);
	      getimage(0, 0, 150, 150, pt);
	      setactivepage(0);
	      putimage(75, 50, pt, 0);
	      setvisualpage(0);
	  }
	  free(pt);
	  getch();
	  closegraph();
	break;
      case 4:
	  Hiz = 0 ;
	  Artis = 1;
	  Konum = 0;
	  detectgraph(&Adapter, &Mod);
	  initgraph(&Adapter, &Mod, dir);
	  setcolor(2);
	  printf("\n   CEVAP 4");
	  setcolor(5);
	  moveto(3, 3);
	  lineto(3, 308);
	  lineto(308, 308);
	  lineto(308, 3);
	  lineto(3, 3);
	  imsize = (0, 0, 50, 300);
	  pt = malloc(imsize);
	  while(!kbhit()){
              setactivepage(1);
	      clearviewport();
	      Hiz += Artis;
	      Konum += Hiz;
	      if(Konum > 280){
		 Konum = 280;
		 Hiz = -sqrt(Hiz*Hiz/2);
	      }
              setcolor(10);
	      circle(25, 10 + Konum, 10);
	      getimage(0, 0, 50, 300, pt);
	      setactivepage(0);
	      putimage(125, 5, pt, 0);
	      setvisualpage(0);
	  }
	  free(pt);
	  getch();
	  closegraph();
	break;
      }
    }
}